#include "IOSAssetManager.h"

#import <Foundation/Foundation.h>
#include <stdlib.h>
#include <string.h>

void IOSAssetManager::create()
{
    ptr = new IOSAssetManager;
}

bool IOSAssetManager::loadFile(const char* path, FileBuffer* p_file_buf)
{
    NSString* search_path = [NSString stringWithUTF8String:path];
    NSString* full_path = [[NSBundle mainBundle] pathForResource:search_path ofType:@"" inDirectory:@"assets"];
    NSData* content = [[NSFileManager defaultManager] contentsAtPath: full_path];
    
    NSUInteger length = [content length];
    
    void *buf = malloc((size_t)length);
    if (!buf)
        return false;
    [content getBytes: buf length: length];
    p_file_buf->data = buf;
    p_file_buf->size = (size_t)length;
    p_file_buf->internal = NULL;
    
    return true;
}

void IOSAssetManager::releaseFileBuffer(FileBuffer& fb)
{
    free((void*)fb.data);
    memset(&fb, 0, sizeof(fb));
}
