#import <Foundation/Foundation.h>
#import "MetalViewDelegate.h"
#import <MetalKit/MetalKit.h>

#import "MetalGfxInterface.h"

void metalGfxPushRect(void* metalGfxObj, KDERect rect, KDEStringHandle texture)
{
    [(__bridge id) metalGfxObj pushRect: rect withTexture: texture];
}

void metalGfxPushFontRect(void* metalGfxObj, KDERect rect, float char_height, KDEStringHandle font, KDEStringHandle key)
{
    [(__bridge id)metalGfxObj pushRect:rect withFont:font withCharHeight:char_height withKey:key];
}

void* metalGfxCreateTexture(void* metalGfxObj, const void* pixels, unsigned int width, unsigned int height, MetalGfxTextureFormat format)
{
    MTLPixelFormat pxFormat = (format == MetalGfxTextureFormat_RGBA)
        ? MTLPixelFormatRGBA8Uint
        : MTLPixelFormatR8Uint;
    return (__bridge_retained void*)[(__bridge id)metalGfxObj createTexture:pixels width:width height:height format:pxFormat];
}

void metalGfxDestroyTexture(void* textureObj)
{
    id<MTLTexture> texture = (__bridge_transfer id)textureObj;
    // Texture should be dropped here
}
