//
//  ShaderTypes.h
//  KDE
//
//  Created by Ronja Enseleit on 01.07.23.
//

//
//  Header containing types and enum constants shared between Metal shaders and Swift/ObjC source
//
#ifndef ShaderTypes_h
#define ShaderTypes_h

#ifdef __METAL_VERSION__
#define NS_ENUM(_type, _name) enum _name : _type _name; enum _name : _type
typedef metal::int32_t EnumBackingType;
#else
#import <Foundation/Foundation.h>
typedef NSInteger EnumBackingType;
#endif

#include <simd/simd.h>

typedef NS_ENUM(EnumBackingType, BufferIndex)
{
    BufferIndexRects         = 0,
    BufferIndexUniforms      = 1
};

typedef NS_ENUM(EnumBackingType, VertexAttribute)
{
    VertexAttributeDstP0   = 0,
    VertexAttributeDstP1   = 1,
    VertexAttributeSrcP0   = 2,
    VertexAttributeSrcP1   = 3,
    VertexAttributeColor   = 4,
    VertexAttributeExpandR = 5
};

typedef NS_ENUM(EnumBackingType, TextureIndex)
{
    TextureIndexColor    = 0,
};

typedef struct
{
    vector_float2 resolution;
} Uniforms;

#endif /* ShaderTypes_h */

